"use strict";
exports.__esModule = true;
function format(sfdxCoverage, coverageResponse, basePath) {
    var body = 'TN:\n';
    var coverageMap = new Map();
    sfdxCoverage.coverage.coverage.forEach(function (apexClass) {
        var path;
        if (apexClass.id.startsWith('01p')) {
            path = process.env.PWD + '/' + basePath + 'classes/' + apexClass.name + '.cls';
        }
        else {
            path = process.env.PWD + '/' + basePath + 'triggers/' + apexClass.name + '.trigger';
        }
        coverageMap.set(path, new Map());
        for (var key in apexClass.lines) {
            coverageMap.get(path).set(parseInt(key), 0);
        }
    });
    coverageResponse.forEach(function (coverage) {
        var path;
        if (coverage.ApexClassOrTrigger.Id.startsWith('01p')) {
            path = process.env.PWD + '/' + basePath + 'classes/' + coverage.ApexClassOrTrigger.Name + '.cls';
        }
        else {
            path = process.env.PWD + '/' + basePath + 'triggers/' + coverage.ApexClassOrTrigger.Name + '.trigger';
        }
        coverage.Coverage.coveredLines.forEach(function (lineNo) {
            coverageMap.get(path).set(lineNo, coverageMap.get(path).get(lineNo) + 1);
        });
    });
    coverageMap.forEach(function (value, key) {
        console.log('Add coverage for ' + key + '...');
        body += 'SF:' + key + '\n';
        value.forEach(function (value, key) {
            body += 'DA:' + key + ',' + value + '\n';
        });
        body += 'end_of_record\n';
    });
    return body;
}
exports["default"] = format;
