import * as fs from 'fs'
import OAuth2 from './tsforce/oauth2'
import { Force } from './tsforce/tsforce'
import formatter from './formatter'

export default async function handle(commander: any) {
  let token, coverage

  // if (!commander.file) {
  //   try {
  //     console.log('Logging in to Salesforce...')
  //     token = await new OAuth2().auth(commander.instance, commander.username, commander.password)
  //   } catch (e) {
  //     console.error(e.message)
  //     process.exit(1)
  //   }

  //   let client = new Force(token)
  //   console.log('Getting coverage...')
  //   coverage = await client.getCoverage()
  // } else {
  let data = JSON.parse(fs.readFileSync(commander.file, 'UTF-8'))
  coverage = data.result.coverage.records
  // }

  console.log('Formatting coverage...')
  let lcovInfo = formatter(data.result, coverage, commander.path)

  console.log('Coverage folder exist?...')
  let folderExist = fs.existsSync(process.env.PWD + '/coverage/')

  if (!folderExist) {
    console.log('Create coverage?...')
    fs.mkdirSync(process.env.PWD + '/coverage/')
  }

  console.log('Saving coverage...')
  console.log(process.env.PWD)
  fs.writeFileSync(process.env.PWD + '/coverage/lcov.info', lcovInfo)
  console.log('File Saved!')
}
